include (jslib_dirutils);
include (jslib_prefs);
include (jslib_fileutils);
include (jslib_file);
include (jslib_dir);

include ("chrome://global/content/strres.js");

function MozImagePrefs() 
{
  this.prefs = new Prefs();
  this.load();
}

MozImagePrefs.prototype = {

load : 
  function () {
    this.homeDir = this.prefs.getChar("mozimage.home_directory");
    this.autoSize = this.prefs.getBool("browser.enable_automatic_image_resizing");
    this.slideshow = this.prefs.getBool("mozimage.slideshow");
    this.delay = this.prefs.getInt("mozimage.delay");
    this.zoom = this.prefs.getChar("mozimage.zoom");
    this.listCollapsed = false;
    this.thumbSize = this.prefs.getChar("mozimage.thumbsize");
    this.orderBy = this.prefs.getChar("mozimage.orderby");
    this.descending = this.prefs.getBool("mozimage.descending");
    this.forceHttpTumb = this.prefs.getBool("mozimage.forcehttptumb");
    if (this.prefs.getType("mozimage.enablecache") == 0) // PREF_INVALID
      this.enableCache = true;
    else
      this.enableCache = this.prefs.getBool("mozimage.enablecache");
    
    if (this.prefs.getType("mozimage.enablecurrent") == 0) 
      this.enableCurrent = true;
    else
      this.enableCurrent = this.prefs.getBool("mozimage.enablecurrent");
   
    this.editorName1 = this.prefs.getChar("mozimage.editorname_1");
    this.editorPath1 = this.prefs.getChar("mozimage.editorpath_1");
    this.editorName2 = this.prefs.getChar("mozimage.editorname_2");
    this.editorPath2 = this.prefs.getChar("mozimage.editorpath_2");
    this.editorName3 = this.prefs.getChar("mozimage.editorname_3");
    this.editorPath3 = this.prefs.getChar("mozimage.editorpath_3");
    this.editorName4 = this.prefs.getChar("mozimage.editorname_4");
    this.editorPath4 = this.prefs.getChar("mozimage.editorpath_4");
    
    this.macroName = new Array();
    this.macroCode = new Array();

    for(var i = 0 ; i < 10 ; i++)
    {
      this.macroName[i] = this.prefs.getChar("mozimage.macroname_" + i);
      this.macroCode[i] = this.prefs.getChar("mozimage.macrocode_" + i);
    }
    
    var extListStr = this.prefs.getChar("mozimage.extlist");
    
    if (this.orderBy == "")
      this.orderBy = "nume";
      
    if (this.thumbSize == "")
      this.thumbSize = 64;
    else
      this.thumbSize = Number(this.thumbSize);
      
    if (extListStr == "")
      this.extList = new Array("jpg", "jpeg", "gif", "bmp", "png");
    else
      this.parseExtStr(extListStr);
      
    
    if (this.delay <= 0)
      this.delay = 2000;
    if (this.zoom <= 1)
      this.zoom = 1.5;
   
    if (this.homeDir == "")
    {
      var dirUtils = new DirUtils();
      this.homeDir = dirUtils.getCurProcDir();
    }
  },
  
parseExtStr :
  function (extListStr) {

    var ext = "";
    this.extList = new Array();

    for(var i = 0 ; i < extListStr.length ; i++)
    {
      if (extListStr[i] == ",")
      {
        this.extList.push(ext);
        ext = "";
      }
      else
        ext = ext + extListStr[i];
    }
    if (ext != "")
      this.extList.push(ext);
  },
  
save : 
  function () {
    this.prefs.setChar("mozimage.extlist", this.extList.toString()); 
    this.prefs.setChar("mozimage.home_directory", this.homeDir); 
    this.prefs.setBool("browser.enable_automatic_image_resizing", this.autoSize); 
    this.prefs.setBool("mozimage.slideshow", this.slideshow); 
    this.prefs.setInt("mozimage.delay", this.delay); 
    this.prefs.setChar("mozimage.zoom", this.zoom); 
    this.prefs.setChar("mozimage.thumbsize", this.thumbSize);
    this.prefs.setChar("mozimage.orderby", this.orderBy);
    this.prefs.setBool("mozimage.descending", this.descending); 
    this.prefs.setBool("mozimage.forcehttptumb", this.forceHttpTumb); 
    this.prefs.setBool("mozimage.enablecache", this.enableCache); 
    this.prefs.setBool("mozimage.enablecurrent", this.enableCurrent); 
    this.prefs.setChar("mozimage.editorname_1", this.editorName1); 
    this.prefs.setChar("mozimage.editorpath_1", this.editorPath1); 
    this.prefs.setChar("mozimage.editorname_2", this.editorName2); 
    this.prefs.setChar("mozimage.editorpath_2", this.editorPath2); 
    this.prefs.setChar("mozimage.editorname_3", this.editorName3); 
    this.prefs.setChar("mozimage.editorpath_3", this.editorPath3); 
    this.prefs.setChar("mozimage.editorname_4", this.editorName4); 
    this.prefs.setChar("mozimage.editorpath_4", this.editorPath4); 

    for(var i = 0 ; i < 10 ; i++)
    {
      this.prefs.setChar("mozimage.macroname_" + i, this.macroName[i]); 
      this.prefs.setChar("mozimage.macrocode_" + i, this.macroCode[i]); 
    }
  },

getHomeDir : 
  function () { return(this.homeDir); },

setHomeDir : 
  function (aValue) { this.homeDir = aValue; },

getListCollapsed : 
  function () { return(this.listCollapsed); },

setListCollapsed : 
  function (aValue) { this.listCollapsed = Boolean(aValue); },

getExtList : 
  function () { return(this.extList); },

setExtList : 
  function (aValue) { this.extList = aValue; },

getAutoSize : 
  function () { return(Boolean(this.autoSize)); },

setAutoSize : 
  function (aValue) { this.autoSize = Boolean(aValue); },

getSlideshow : 
  function () { return(Boolean(this.slideshow)); },

setSlideshow : 
  function (aValue) { this.slideshow = Boolean(aValue); },

getDelay : 
  function () { return(Number(this.delay)); },

setDelay : 
  function (aValue) { this.delay = Number(aValue); },
  
getZoom : 
  function () { return(Number(this.zoom)); },

setZoom : 
  function (aValue) { this.zoom = Number(aValue); },

getThumbSize : 
  function () { return(Number(this.thumbSize)); },

setThumbSize : 
  function (aValue) { this.thumbSize = Number(aValue); },

getOrderBy : 
  function () { return(this.orderBy); },

setOrderBy : 
  function (aValue) { this.orderBy = aValue; },

getDescending : 
  function () { return(Boolean(this.descending)); },

setDescending : 
  function (aValue) { this.descending = Boolean(aValue); },
  
getForceHttpTumb : 
  function () { return(Boolean(this.forceHttpTumb)); },

setForceHttpTumb : 
  function (aValue) { this.forceHttpTumb = Boolean(aValue); },
  
getEnableCache : 
  function () { return(Boolean(this.enableCache)); },

setEnableCache : 
  function (aValue) { this.enableCache = Boolean(aValue); },
  
getEnableCurrent : 
  function () { return(Boolean(this.enableCurrent)); },

setEnableCurrent : 
  function (aValue) { this.enableCurrent = Boolean(aValue);  },  

getMacroName : 
  function () { return(this.macroName); },

setMacroName : 
  function (aValue) { this.macroName = aValue; },

getMacroCode :
  function () { return(this.macroCode); },

setMacroCode : 
  function (aValue) { this.macroCode = aValue; },

getEditorsName:
  function () { return(new Array(this.editorName1, this.editorName2, this.editorName3, this.editorName4)); },
  
setEditorsName:
  function (aValue) { 
    this.editorName1 = aValue[0];
    this.editorName2 = aValue[1];
    this.editorName3 = aValue[2];
    this.editorName4 = aValue[3];
  },

getEditorsPath:
  function () { return(new Array(this.editorPath1, this.editorPath2, this.editorPath3, this.editorPath4)); },
  
setEditorsPath:
  function (aValue) { 
    this.editorPath1 = aValue[0];
    this.editorPath2 = aValue[1];
    this.editorPath3 = aValue[2];
    this.editorPath4 = aValue[3];
  },

toggleExt :
  function (aExt) {
    var index = -1;
    for(var i = 0 ; i < this.extList.length ; i++)
    {
      if (this.extList[i] == aExt)
        index = i;
    }
    if (index != -1)
      this.extList.splice(index, 1);
    else
      this.extList.push(aExt);
  },

toggleDes :
  function () {
    this.setDescending(!this.getDescending());
  },
  
toggleForceHTTPTumb :
  function () {
    this.setForceHttpTumb(!this.getForceHttpTumb());
  },
  
toggleEnableCache :
  function () {
    this.setEnableCache(!this.getEnableCache());
    },

getFolder:
  function () {
    try {
      var selectdir = window.arguments[1];
      var nsIFilePicker = Components.interfaces.nsIFilePicker;
      var fp = Components.classes["@mozilla.org/filepicker;1"].createInstance(nsIFilePicker);
      fp.init(window, selectdir, nsIFilePicker.modeGetFolder);
      var res = fp.show();
      if (res == nsIFilePicker.returnOK) 
      {
        var thepath = fp.file;
        document.getElementById('homedir-text').value = thepath.path; 
      }
    } 
    catch (e) { alert(e); }
  },

setCurrent:
  function () {
    try {
      var fullpath =  window.arguments[0];
      document.getElementById('homedir-text').value = fullpath.value;
    } catch (e) { alert (e); };
  },

toggleEnableCurrent :
  function () {  
    this.setEnableCurrent(!this.getEnableCurrent());
    try {
      if (this.getEnableCurrent())
      {
        document.getElementById("homedir-text").setAttribute("disabled","true");
        document.getElementById("folder-button").setAttribute("disabled","true");
        document.getElementById("current-button").setAttribute("disabled","true");
      }
      else
      {
        document.getElementById("homedir-text").setAttribute("disabled","false");
        document.getElementById("folder-button").setAttribute("disabled","false");
        document.getElementById("current-button").setAttribute("disabled","false");
      }
    } catch (e) { alert (e);} 
  }
} // END CLASS

/*
**
** Predefined instance of the preferences class
** do not use any other instances
**
*/

var prefs = new MozImagePrefs();

/*
**
** Prefs window event handlers
**
*/

function prefs_load()
{
  var homedir = document.getElementById("homedir-text");
  var delay = document.getElementById("delay-text");
  var zoom = document.getElementById("zoom-text");
  var thumbSize = document.getElementById("thumb-menu");
  var orderBy = document.getElementById("orderby-menu");
  var desChk = document.getElementById("descending-check");
  var forceHttpTumbChk = document.getElementById("forcehttptumb-check");
  var enableCacheChk = document.getElementById("enablecache-check");

  var enableCurrentChk = document.getElementById("enablecurrent-check");
  try {
    if (prefs.getEnableCurrent())
    {   
      document.getElementById("homedir-text").setAttribute("disabled","true");
      document.getElementById("folder-button").setAttribute("disabled","true");
      document.getElementById("current-button").setAttribute("disabled","true");
    }
  } catch (e) { alert(e); }

  prefs.load();
  var extList = prefs.getExtList();

  homedir.value = prefs.getHomeDir();
  delay.value = prefs.getDelay() / 1000;
  zoom.value = prefs.getZoom();
  var editorsName = prefs.getEditorsName();
  var editorsPath = prefs.getEditorsPath();
  thumbSize.value = prefs.getThumbSize();
  orderBy.value = prefs.getOrderBy();
  desChk.checked = prefs.getDescending();
  forceHttpTumbChk.checked = prefs.getForceHttpTumb();
  enableCacheChk.checked = prefs.getEnableCache();
  enableCurrentChk.checked = prefs.getEnableCurrent();

  for(var i = 0 ; i < extList.length ; i++)
  {
    var checkbox = document.getElementById(extList[i] + "-check");
    checkbox.checked = true;
  }
  for(var i = 1 ; i <= 4 ; i++)
  {
    var edit = document.getElementById("editorname" + i + "-text");
    edit.value = editorsName[i-1];
    var edit = document.getElementById("editorpath" + i + "-text");
    edit.value = editorsPath[i-1];
  }
}

function prefs_close()
{
  var homedir = document.getElementById("homedir-text");
  var delay = document.getElementById("delay-text");
  var zoom = document.getElementById("zoom-text");
  var thumbMenu = document.getElementById("thumb-menu");
  var orderByMenu = document.getElementById("orderby-menu");
  var editorsName = new Array();
  var editorsPath = new Array();
  prefs.setHomeDir(homedir.value);
  prefs.setDelay(delay.value * 1000);
  prefs.setZoom(zoom.value);

  for(var i = 1 ; i <= 4 ; i++)
  {
    var edit = document.getElementById("editorname" + i + "-text");
    editorsName[i-1] = edit.value;
    var edit = document.getElementById("editorpath" + i + "-text");
    editorsPath[i-1] = edit.value;
  }
  prefs.setEditorsName(editorsName);
  prefs.setEditorsPath(editorsPath);
  prefs.setThumbSize(thumbMenu.value);
  prefs.setOrderBy(orderByMenu.value);

  prefs.save();
}

function macros_load()
{
  prefs.load();
  var macroName = prefs.getMacroName();
  var macroCode = prefs.getMacroCode();
  for(var i = 0 ; i < 10 ; i++)
  {
    var edit = document.getElementById("macroname" + i + "-text");
    edit.value = macroName[i];
    var edit = document.getElementById("macrocode" + i + "-text");
    edit.value = macroCode[i];
  }
}

function macros_close(event)
{
  var macroName = new Array();
  var macroCode = new Array();

  for(var i = 0 ; i < 10 ; i++)
  {
    var edit = document.getElementById("macroname" + i + "-text");
    macroName[i] = edit.value;
    var edit = document.getElementById("macrocode" + i + "-text");
    macroCode[i] = edit.value;
  }
  prefs.setMacroName(macroName);
  prefs.setMacroCode(macroCode);
  prefs.save();
}
